// iiNet Usage Widget JavaScript App Code.

// (c) 2008 LemonJar Pty Ltd. All Rights Reserved.
// http://www.lemonjar.com/

var version = "v1.61"; 
var widgetName = "iiNetUsage";
var defaultPeakBarColor = "#FFFFFF";
var defaultOffPeakBarColor = "#FFFFFF";
var updateurl = 'http://updates.lemonjar.com/?product=iinetusage&type=widget&version=' + version;

function loadXMLDoc(){
	debug("Function: loadXMLDoc() run.");
	if (!debugMode){ // false
		var url =  "https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi?";
			url += "username=" + userName;
			url += ";password=" + psword;
			url += ";action=login";
	} else {  		 // true
		var url =  "http://devweb/iinet1.html";
	}
	
	var xmlhttp;
	var result = null;
	
	try{
		xmlhttp = new XMLHttpRequest();
		xmlhttp.overrideMimeType("text/xml");
		xmlhttp.onreadystatechange =  function(){
					if (xmlhttp.readyState == 4){
						if (xmlhttp.status == 200) {
							error(""); // clear error.
							result = xmlhttp;
							debug("xmlhttp fetch == success!")
						} else {
							result = xmlhttp.status;
							debug("xmlhttp fetch == fail! Reason = " + result);
						}
					}};					
		xmlhttp.open("GET", url, false);
		xmlhttp.setRequestHeader("Cache-Control", "no-cache");
		xmlhttp.send(null);
	} catch (e) {
		error("Exception in xmlFetch : exception caught");
	}
	
	debug("loadXMLDoc() returning = " + result);
	return result;
}

//Fetch then Tabulate data from xml.
function fetchAndTabulateData() {
debug("Function: fetchAndTabulateData() run.");

// Get XML - Load in.
	var xmlhttp = loadXMLDoc();
	
	if (xmlhttp == "-1009"){
		// Not connected
		debug("-1009 = Not showing error window so that old data can be read.");
		// Show old data.
		error("");
		return false;
	}
	
	if (xmlhttp == "-1012"){
		// Auth. Failed
		// Show Error box (Check User Password).
		debug("-1012 = Auth Failed. Show Error Box.");
		error("Auth. Failed :<br /> Please check your Username and Password.");
		return false;
	}

	if (xmlhttp == "-1003"){
		// Server Was Unreachable.
		// Show Error box (Server Was Unreachable.).
		debug("-1003 = Comm Failed. Show Error Box.");
		error("Comm. Failed :<br /> Unable to Connect to server.");		
		return false;
	}
	
	if (xmlhttp == "404"){
		// File Not Found On Server
		// Show Error box (File Not Found On Server.).
		debug("404 = Server Error: Show Error Box.");
		error("Server Error : 404 <br /> File Not Found On Server.");		
		return false;
	}
	
	var reply = xmlhttp.responseText;

	//test for password in page. < means password (login) failed.
    var passwordRegex = /password/;
    if(passwordRegex.test(reply)){
    	error("Invalid Login.");
    	return false;
    }

//-------------{Usage Tree}-----------------

//midnight on the <font color=green>2nd</font>
    var endDayRegex = /on the <font color=green>(\d*)/g;
    var endDay = endDayRegex.exec(reply);
    // endOfMonthDay : endDay = [1]
    
	debug("endDay returned = " + endDay); //debug

    var limitRegex = /(\d*) MB Peak time, (\d*) MB Offpeak/g;
    var limits = limitRegex.exec(reply);
    // Limits : Peak = [1]  OffPeak = [2]

    var usedQuotaRegex = /<TD ALIGN=left><B>Total<\/B><\/TD>\n          <TD><B>&nbsp;<\/TD>\n          <TD><B>(\d+\.?\d*)<\/B><\/TD>\n          <TD><B>(\d+\.?\d*)<\/B><\/TD>/g;
    var usedQuotaResult = usedQuotaRegex.exec(reply);
	// Used Quota : peak = [1] OffPeak = [2]

// break on what looks like an error in data parsing.
	if (endDay == null){
		error("Error in Regex, EndDay was unable to be found in page.");
		return false;
	}
	
    if(limits.index < 0 || usedQuotaResult.index < 0){
		error("Data Parsing Error.");
		return false;
    }

	//Data
	var peakTotal = "0";
	var offpeakTotal = "0"; 
	var peakLimit = "0";
	var offpeakLimit = "0";
	var planName = "";
	var update = "";
	var startDay = ""

//fill vars.	
	peakTotal = usedQuotaResult[1];
	peakLimit = limits[1];
	offpeakTotal = usedQuotaResult[2]; 
	offpeakLimit = limits[2];   
	startDay = parseInt(endDay[1]);  // don't add 1 because iiNet "midnight" is actually the morning of rollover day!

	
//	update = getTime();
	
// Pass Results Off To Display Function.
	debug("Return Data To parent in array.");
	
	// Add all the Data to Array.
	var results = new Array(12);
	
		// Data Format.	
		/* 	results[0]  = ; // Show Peak Bar? Boolean = true or false. */
		/* 	results[1]  = ; // Peak Total. */
		/* 	results[2]  = ; // Peak Limit. */
		
		/* 	results[3]  = ; // Show Off Peak Bar? Boolean = true or false. */
		/* 	results[4]  = ; // Off Peak Total. */
		/* 	results[5]  = ; // Off Peak Limit. */
		
		/* 	results[6]  = ; // Show Free data Used? Boolean = true or false. */
		/* 	results[7]  = ; // Free Data Used. */
		
		/* 	results[8]  = ; // Data Last Updated. */
		/* 	results[9]  = ; // Plan Name.	 */
		/* 	results[10] = ; // Plan Start Day.	 */
		

	results[0] = "true"; // Show Peak Bar? Boolean = true or false.
	results[1] = peakTotal; // Peak Total.
	results[2] = peakLimit; // Peak Limit.
	
	results[3] = "true"; // Show Off Peak Bar? Boolean = true or false.
	results[4] = offpeakTotal; // Off Peak Total.
	results[5] = offpeakLimit; // Off Peak Limit.
	
	results[6] = "false"; // Show Free data Used? Boolean = true or false.
	results[7] = "0"; // Free Data Used.
	
	results[8] = getTime(); // Data Last Updated.
	results[9] = planName; // Plan Name.
 	results[10] = startDay; // Plan Start / RollOver Day.
				
	debug("array = " + results);
	return results;
}

// get current time.
function getTime() {
  var curtime = new Date();
  var curhour = curtime.getHours();
  var curmin = curtime.getMinutes();
  var cursec = curtime.getSeconds();
  var time = "";

  if(curhour == 0) curhour = 12;
  time = (curhour > 12 ? curhour - 12 : curhour) + ":" +
         (curmin < 10 ? "0" : "") + curmin + ":" +
         (cursec < 10 ? "0" : "") + cursec + " " +
         (curhour > 12 ? "PM" : "AM");

return time;
}