// Usage Widget JavaScript App Code.

// (c) 2006 Richard Heard. All Rights Reserved.
// http://www.phoenixonline.co.uk/

// (c) 2008 LemonJar Pty Ltd. All Rights Reserved.
// http://www.lemonjar.com/

// Portions (c) 2005 Apple Computer Inc. All rights reserved.
// http://www.apple.com/

//	 Global XML Instance, Version, Username & Password Variables. 
var debugMode = false;
var userName;
var psword;
var alertColorOn;

// Run On Startup.
function init(){
	debug(widgetName + " " + version + " loaded - " + (new Date()).getTime());
	showDebug();
	genButtons();
	readPrefs();
	loop(); // fetch xml, parse it, and then spit it out to the screen.
	// check for updates on load.
	checkForUpdates();	
}
function loop(){
	debug("Function: loop() run.");
	var result = fetchAndTabulateData(); //Get and Parse XML.
	debug(result); // debug.
	printToScreen(result);
}

//Run on Show (Dashboard).
if (window.widget){
	widget.onshow = function() {
		debug("Function: widget.onshow() run.");
		
		statusmsg("Updating ISP Data..");
		setTimeout('statusmsg("");',1500);
		
		loop(); // fetch xml, parse it, and then spit it out to the screen.
		
		// delay check so that it isnt overwriten by the clearing of the "Updateing.."
		setTimeout('checkForUpdates();',1600);
	}
}

//Output Stats To Div's.
function printToScreen(data){
	debug("Function: printToScreen() run. ");

	if (data == false){
		debug("printToScreen - Ending suddenly as did not recieve array of values.");
		return; // Do nothing. Error / function already displayed.
	}
	 //Read in data from array.
	var showPeakBar 	= data[0]; // Show Peak Bar? Boolean = true or false.
	var peakTotal 		= parseInt(data[1], 10); // Peak Total.
	var peakLimit 		= parseInt(data[2], 10); // Peak Limit.
			
	var showOffPeakBar 	= data[3]; // Show Off Peak Bar? Boolean = true or false.
	var offPeakTotal 	= parseInt(data[4], 10); // Off Peak Total.
	var offPeakLimit 	= parseInt(data[5], 10); // Off Peak Limit.
	
	var showFreeData 	= data[6]; // Show Free data Used? Boolean = true or false.
	var freeTotal 		= parseInt(data[7], 10); // Free Data Used.
	
	var lastUpdated 	= data[8]; // Data Last Updated.
	var planName 		= data[9]; // Plan Name.	
	var startDay 		= parseInt(data[10], 10); // Plan Start day.	

//Calculate Days Remaining.
	var daysLeft;
	var today = new Date().getDate();
	debug("today = " + today); //debug
	
	if (today < startDay){ // resets during this month.
		daysLeft = ( (startDay - today) - 1);
	} else { // resets during next month.
		daysLeft = ( (daysInMonth( new Date().getMonth() ) - today) + startDay ) - 1;
	}

	document.getElementById("highinfo").innerHTML = "" + daysLeft + " days left.";
	
	// If less than 1 day remaining show hours :)
	if (daysLeft == 0){
		var hoursLeft = ( 24 - new Date().getHours() );
		document.getElementById("highinfo").innerHTML = "0 days " + hoursLeft + " hours left.";
	}
	
//Calculate Day Bar Width. // disabled till next release. 
 	var daysWidth = 200 - Math.round(( daysLeft / 30) * 100 *2);
	debug("daysWidth = " + daysWidth + "px");
	document.getElementById("peakdaybar").style.width = daysWidth;
	if (showOffPeakBar == "true"){
		document.getElementById("offpeakdaybar").style.width = daysWidth;
	}
	
//Calculate Peak Data Percentage used.
	if (showPeakBar == "true"){
		var peakWidth = Math.round((peakTotal / peakLimit) * 100 *2);
	
		if (peakWidth > 200)
			peakWidth = 200;
	
		if (alertColorOn == true) //true // check to see if user has color option selected
			document.getElementById("peakbar").style.backgroundColor = barColor(peakWidth);
		else //false
			document.getElementById("peakbar").style.backgroundColor = defaultPeakBarColor;
		document.getElementById("peakbar").style.width = peakWidth;
		document.getElementById("peakbarcenteroverlay").innerHTML = Math.round((peakTotal / peakLimit) * 100) + " %";
		document.getElementById("peakbarleftoverlay").innerHTML = Math.round(peakTotal) + " MB";
		document.getElementById("peakbarrightoverlay").innerHTML = Math.round(parseInt(peakLimit, 10) - parseInt(peakTotal, 10)) + " MB";
		document.getElementById("peakbarquota").innerHTML = Math.round(parseInt(peakLimit, 10)) + " MB";
	}
//Calculate Off-Peak Data Percentage used.
	if (showOffPeakBar == "true"){
	
		var offPeakWidth = Math.round((offPeakTotal / offPeakLimit) * 100 *2);
		
		if (offPeakWidth > 200)
			offPeakWidth = 200;
	
		if (alertColorOn == true) //true // check to see if user has color option selected
			document.getElementById("offpeakbar").style.backgroundColor = barColor(offPeakWidth);
		else //false
			document.getElementById("offpeakbar").style.backgroundColor = defaultOffPeakBarColor;
		document.getElementById("offpeakbar").style.width = offPeakWidth;
		document.getElementById("offpeakbarcenteroverlay").innerHTML = Math.round((offPeakTotal / offPeakLimit) * 100) + " %";
		document.getElementById("offpeakbarleftoverlay").innerHTML = Math.round(offPeakTotal) + " MB";
		document.getElementById("offpeakbarrightoverlay").innerHTML = Math.round(parseInt(offPeakLimit, 10) - parseInt(offPeakTotal, 10)) + " MB";
		document.getElementById("offpeakbarquota").innerHTML = Math.round(parseInt(offPeakLimit, 10)) + " MB";
	}	
	
	if (showFreeData == "true"){
		document.getElementById("lowinfo").innerHTML = "Free ( " + freeTotal + " MB )";
	} else {
		document.getElementById("lowinfo").innerHTML = lastUpdated;
	}
	
	document.getElementById("planName").innerHTML = planName;

}

function keyForUsername() { return widget.identifier + "-" + "userName"; }
function keyForPassword() { return widget.identifier + "-" + "psword"; }
function keyForAlertCol() { return widget.identifier + "-" + "alertColorOn"; }

//Read in Username & Password Stored in OS .plist. Updates Global Variables.
function readPrefs(){
	debug("Function: readPrefs() run.");

	if(window.widget) { 
		var TMPuserName = widget.preferenceForKey(keyForUsername()); 
		var TMPpsword = widget.preferenceForKey(keyForPassword()); 
		var TMPalertColorOn = widget.preferenceForKey(keyForAlertCol()); 

		if ( TMPuserName && TMPuserName.length > 0) { 
			userName = TMPuserName;
		} else {
			userName = "";
		}
		
		if ( TMPpsword && TMPpsword.length > 0) { 
			psword = rot13(TMPpsword);
		} else {
			psword = "";
		}
		
		if (TMPalertColorOn == true) { 
			alertColorOn = true;
		} else {
			alertColorOn = false;
		}
		
		document.getElementById("userNamePref").value = userName;
		document.getElementById("pswordPref").value = psword;
		document.getElementById("alertColorPref").checked = alertColorOn;
		
		// If details not entered, show back of widget
		if (userName == "" && psword == "") {
			showBack();
		}
	} 
}

//Create the Button's [Done]
function genButtons(){
	debug("Function: genButtons() run.");

	createGenericButton(document.getElementById("doneButton"), "Done", hideBack());
	// Add Menu Here So That If Logon Fails Its Still Passed Out To Be Displayed.
	var year = new Date().getYear() + 1900;
	document.getElementById("about").innerHTML = "&copy; " + year;
	document.getElementById("version").innerHTML = version;
}

// Writes prefs to OS Store .PList
function savePrefs(){
	debug("Function: savePrefs() run.");

	//For in browser JS Use.
	userName = document.getElementById("userNamePref").value;
	psword = document.getElementById("pswordPref").value;
	alertColorOn = document.getElementById("alertColorPref").checked;

	if(window.widget){ 	
		widget.setPreferenceForKey(document.getElementById("userNamePref").value, keyForUsername());
		widget.setPreferenceForKey(rot13(document.getElementById("pswordPref").value), keyForPassword());
		widget.setPreferenceForKey(document.getElementById("alertColorPref").checked, keyForAlertCol());
	}	
}


//-----------Utils-------------

// Find days in given month. 
function daysInMonth(month){
	debug("Function: daysInMonth("+month+") run.");
	var daysInMonth   = new Array( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
	var daysInMonthLY = new Array( 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
		
	var year = new Date().getYear();
	if (((year % 4 == 0) && (year % 100 != 0)) || (year % 400 == 0)) // does not handle yr2000
		daysInMonth = daysInMonthLY; // its a leap year.

debug("Days In Month = " + daysInMonth[month]);
return daysInMonth[month];

}

// Convert Strings To Upercase 1st Chars. 
function initialCaps(theString) {
	debug("Function: initialCaps(" + theString + ") run.");

	theString = theString.toLowerCase(); //make all lower case.
	theString = theString.substr(0, 1).toUpperCase() + theString.substring(1, theString.length);
	var i = 0;
	var j = 0;
	
	while((j = theString.indexOf(" ", i)) && (j != -1)) {
		theString = theString.substring(0, j + 1) + 
					  theString.substr(j + 1, 1).toUpperCase() + 
						 theString.substring(j + 2, theString.length);
		i = j+1;
	}

	return theString; //Return String.
}

// Open Passed URL In Browser.
function gotoURL(url){ 
	debug("Function: goToURL( " + url + " ) run.");
	
	if (widget)
		widget.openURL(url);
} 

// Status Print Out. 
function statusmsg(msg){
	debug("Function: statusmsg(" + msg + ") run.");
	document.getElementById("status").innerHTML = msg;
	document.getElementById("status").style.textDecoration = "none";

}
//Status Print Out. + URL Link. (For updated version linking.)
function statusmsgurl(msg, url){
	debug("Function: statusmsgurl(" + msg + url + ") run.");
	
	document.getElementById("status").innerHTML = msg;
	document.getElementById("status").style.textDecoration = "underline";

}

// Error Print Out. 
function error(msg){
	debug("Function: error(" + msg + ") run.");

	var error = document.getElementById("error");

	if (msg == ""){
		error.style.display="none";
		error.innerHTML = "";
		debug("Error: Hidden.");

	} else {
		error.style.display="block"; 
		error.innerHTML = initialCaps("error: " + msg);
		debug("Error: Shown.");
	}
}

// ROT13 Encode.
function rot13(text){
	debug("Function: rot13(" + text + ") run.");

	var changed = "";
	for (i = 1 ; i < (text.length + 1); i++) {
		k = text.charCodeAt(i-1);
		if (k >= 97 && k <= 109) {
			k = k + 13;
		} else if (k >= 110 && k <= 122) {
			k = k - 13;
		} else if (k >= 65 && k <= 77) {
			k = k + 13;
		} else if (k >= 78 && k <= 90) {
			k = k - 13;
		}
		changed += String.fromCharCode(k);
	}
	return changed;
}

// Return color based on total usage for bar.
// Thanks goes to Kim Hunter for this sugestion.
function barColor(totalUsed) {
    if (totalUsed < 100)
        color = '#33CC00'; //Green 0-49%
    else if (totalUsed < 150)
        color = '#FFCC00';//yellow 50-74%
    else if (totalUsed < 180)
        color = '#FF7400';//orange 75-89%
    else
        color = '#FF0000';//red 90-100%
    return color; 
}

//Debug Console Stuff.

// Write to the debug div when in Safari.
// Send a simple alert to Console when in Dashboard.
function debug(str) {
	if (debugMode) {
		if (window.widget) {
			alert(str);
		} else {
			var debugDiv = document.getElementById('debugDiv');
			debugDiv.appendChild(document.createTextNode(str));
			debugDiv.appendChild(document.createElement("br"));
			debugDiv.scrollTop = debugDiv.scrollHeight;
		}
	}
}

// Enable / Debug the Debug Box if debugmode = true and in Safari.
function showDebug() {
	
	if (debugMode == true && !window.widget) {
		document.getElementById('debugDiv').style.display = 'block';
	} else {
		document.getElementById('debugDiv').style.display = 'none';
	}
}

// string trim function
function trim(str)
{
   return str.replace(/^\s*|\s*$/g,"");
}

//CheckFor Updates.

//Global Update Object
var updateObg;
var lastUpdateCheck = 0;
var latestversion = "";
var newversionout = false;

function checkForUpdates(){
	debug("Function: checkForUpdates() run.");

if (newversionout == true){
	debug("Already found that there is a new version out. Re-Displaying the mesage and returning.")
	statusmsgurl("A new version (" + latestversion + ") is available.", "http://lemonjar.com/?p=products.widgets");
	return;
}
// Do some funky timestamp check.. Check for updates only once every 12 hours.
// Store it in some variable.
// If < 12hours has passed return.

if ( (lastUpdateCheck + 43200 ) > (new Date()).getTime()) { // 60*60*12 = 43200 seconds
	debug("Already Checked For updates in the last 12 hours. Aborting Update Check.");
	return;
}

	//uses updateurl from sip .js 	
	try{
		updateObg = new XMLHttpRequest();
		updateObg.overrideMimeType("text/xml");
		updateObg.onreadystatechange = processUpdateChange;
		updateObg.open("GET", updateurl, false);
		updateObg.setRequestHeader("Cache-Control", "no-cache");
		updateObg.send(null);
		
	} catch (e) {
		debug("Exception in updateFetch : Exception Caught.");
		return;
	}
}

function processUpdateChange() {
debug("Function: processUpdateChange() run. : Ready State=" + updateObg.readyState);

// Only If update Shows "Loaded"(4)
	if (updateObg.readyState == 4) {
	// OK
		if (updateObg.status == 200) {
		//If fetch was a success update the timestamp.
			lastUpdateCheck = (new Date()).getTime();
		// Carry out Processing Functions.
			latestversion = updateObg.responseText;
			debug("latest version = " + latestversion);

			var update = document.getElementById("update");
			update.style.display="none"; 

			if ((trim(version.split("v")[1])) < (trim(latestversion.split("v")[1])) ){
				statusmsgurl("A new version (" + latestversion + ") is available.", "http://lemonjar.com/?p=products.widgets");
				
				var update = document.getElementById("update");
			
				update.style.display="block"; 
				debug("Update Bubble: Shown.");	
				
				debug("setting newversionout = TRUE");
				newversionout = true;
			}
		} else {
			debug("Error: Fetch of update information was not successful.");
		}
	}
	
}

//----- Begin Apple Std Code ------------
// Apple Default Swap Sides Javascript Function.
function showBack(){
	debug("Function: Apple: showBack() run.");

	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget)
		widget.prepareForTransition("ToBack");
	front.style.display="none";
	back.style.display="block";
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}
function hideBack(){
	debug("Function: Apple : hideBack() run.");

	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget)
		widget.prepareForTransition("ToFront");
	back.style.display="none";
	front.style.display="block";
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0,
	firstElement:null, timer:null};
function mousemove (event){
	//debug("Function: Apple: mousemove(event) run.");

	if (!flipShown){
		if (animation.timer != null){
			clearInterval (animation.timer);
			animation.timer	 = null;
		}
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}
function mouseexit (event){ 
	//debug("Function: Apple: mouseExit(event) run.");

	if (flipShown){
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer	 = null;
		}
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}
function animate(){
	//debug("Function: Apple: animate() run.");

	var T;
	var ease;
	var time = (new Date).getTime();
	T = limit_3(time-animation.starttime, 0, animation.duration);
	if (T >= animation.duration){
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	} else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c){
	return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease){
	return from + (to - from) * ease;
}
function enterflip(event){
	document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event){
	document.getElementById('fliprollie').style.display = 'none';
}

//----- End Apple Std. Code ------------